//
//  BaseNavgationController.m
//  丈子头
//
//  Created by 高宇 on 16/9/29.
//  Copyright © 2016年 高宇. All rights reserved.
//

#import "BaseNavgationController.h"
#import "MoreView.h"

@interface BaseNavgationController ()<MoreViewdelegate>
{
    BOOL isMore;
}

@property (strong, nonatomic) UIView *backView;

@end

@implementation BaseNavgationController

#pragma mark  - 懒加载
- (UIView *)backView
{
    if (!_backView) {
        _backView = [[UIView alloc] initWithFrame:SCREEN_BOUNDS];
        _backView.hidden = 0;
        _backView.backgroundColor = [UIColor clearColor];
        UITapGestureRecognizer *recognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(hiddenBackView)];
        [_backView addGestureRecognizer:recognizer];
        MoreView *moreView = [MoreView sharedSingleton];
        moreView.delegate = self;
        moreView.center = CGPointMake(SCREEN_WIDTH - moreView.bounds.size.width * 0.5 - 10, moreView.bounds.size.height * 0.5 + 54);
        [_backView addSubview:moreView];
    }
    return _backView;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    isMore = NO;
    [self.navigationBar setBarTintColor:[UIColor greenColor]];
    self.navigationBar.barStyle = UIStatusBarStyleDefault;
}

#pragma mark  - 重写push方法
- (void)pushViewController:(UIViewController *)viewController animated:(BOOL)animated
{
    if (self.viewControllers.count > 0) {
        //对二级页面 导航栏重新设置
        [self.navigationBar setBarTintColor:RGB(244, 245, 246)];
        self.navigationBar.barStyle = UIStatusBarStyleDefault;
        
        UIButton *btn = [[UIButton alloc] initWithFrame:CGRectMake(0, 0, 44, 44)];
        [btn setImage:[UIImage imageNamed:@"nav_back"] forState:UIControlStateNormal];
        btn.imageEdgeInsets = UIEdgeInsetsMake(0, -30, 0, 0);
        btn.tintColor = [UIColor colorWithRed:0.42f green:0.33f blue:0.27f alpha:1.00f];
        UIBarButtonItem *leftItem = [[UIBarButtonItem alloc] initWithCustomView:btn];
        [btn addTarget:self action:@selector(popViewControllerAnimated:) forControlEvents:UIControlEventTouchUpInside];
        viewController.navigationItem.leftBarButtonItem = leftItem;
        
        UIButton *rightButton = [UIButton buttonWithType:UIButtonTypeCustom];
        rightButton.bounds = CGRectMake(0, 0, 24, 24);
        [rightButton setImage:[UIImage imageNamed:@"nav_more"] forState:UIControlStateNormal];
        [rightButton addTarget:self action:@selector(rightTabBarClick) forControlEvents:UIControlEventTouchUpInside];
        UIBarButtonItem *rightItem = [[UIBarButtonItem alloc] initWithCustomView:rightButton];
        viewController.navigationItem.rightBarButtonItem = rightItem;
    }
    [super pushViewController:viewController animated:animated];
}

- (void)hiddenBackView{
    __weak BaseNavgationController *weakSelf = self;
    [UIView animateWithDuration:0.5 animations:^{
        weakSelf.backView.alpha = 0;
        isMore = !isMore;
    } completion:^(BOOL finished) {
        [weakSelf.backView removeFromSuperview];
        weakSelf.backView = nil;
    }];
}

#pragma mark  - more按钮点击事件
- (void)rightTabBarClick
{
    UIWindow *window = [UIApplication sharedApplication].keyWindow;
    [window addSubview:self.backView];
    __weak BaseNavgationController *weakSelf = self;
    self.backView.alpha = 0;
    if (!isMore) {
        [UIView animateWithDuration:0.5 animations:^{
            weakSelf.backView.alpha = 0.5;
            isMore = !isMore;
        }];
    }else{
        [UIView animateWithDuration:0.5 animations:^{
            weakSelf.backView.alpha = 0;
            isMore = !isMore;
        } completion:^(BOOL finished) {
            [weakSelf.backView removeFromSuperview];
            weakSelf.backView = nil;
        }];
    }
    
}

#pragma mark - MoreViewDelegate代理方法
- (void)moreViewPushVCWithTag:(NSInteger)tag
{
    self.backView.alpha = 0;
    isMore = !isMore;
    _backView = nil;
    
    NSInteger count = tag - 20001;
    
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"提示" message:[NSString stringWithFormat:@"点击了第%ld按钮",count] preferredStyle:UIAlertControllerStyleAlert];
    [self presentViewController:alert animated:YES completion:nil];
    
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        [alert dismissViewControllerAnimated:YES completion:nil];
    }];
    [alert addAction:okAction];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}


@end
